#include <stdio.h>
#include <stdlib.h>

#include "drzewo.h"

// -- rozwiązanie (TW, 2025-01-15)
Twezel *_oberwij(Twezel *d) {
    if (d==NULL) return NULL;
    if (d->lsyn == d->psyn) {
        free(d);
        return NULL;
    }
    d->lsyn = _oberwij(d->lsyn);
    d->psyn = _oberwij(d->psyn);
    return d;
}

void oberwij_liscie(Twezel **d) {
    *d = _oberwij(*d);
}
// ------------------------------

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    oberwij_liscie(&d);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}