#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "drzewo.h"

// -- rozwiązanie (TW, 2025-01-15)
Twezel *_odrzuc(Twezel *d, int a, int b) {
    if (d==NULL) return NULL;
    d->lsyn = _odrzuc(d->lsyn, a, b);
    d->psyn = _odrzuc(d->psyn, a, b);
    if (d->w < a) {
        assert(d->lsyn == NULL);
        Twezel *wynik = d->psyn;
        free(d);
        return wynik;
    } else if (d->w > b) {
        assert(d->psyn == NULL);
        Twezel *wynik = d->lsyn;
        free(d);
        return wynik;
    } else {
        assert(a <= d->w && d->w <= b);
        return d;
    }
}

void odrzuc(Twezel **d, int a, int b) {
    *d = _odrzuc(*d, a, b);
}
// ----------------------------------

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    odrzuc(&d, 20, 50);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}