#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "drzewo.h"

// -- rozwiązanie (TW, 2025-01-15)
Twezel *_splaszcz(Twezel *d, Twezel *ost) {
    assert(ost != NULL);
    if (d == NULL) return ost;
    ost = _splaszcz(d->lsyn, ost);
    ost->psyn = d;
    ost = d;
    ost->lsyn = NULL;
    ost = _splaszcz(d->psyn, ost);
    return ost;
}

Twezel *splaszcz(Twezel *d) {
    if (d==NULL) return NULL;
    Twezel *straznik = nowy(42, NULL, NULL);
    _splaszcz(d, straznik);
    Twezel *wynik = straznik->psyn;
    free(straznik);
    return wynik;
}
// -----------------------------

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    d = splaszcz(d);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}