#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "drzewo.h"

// -- rozwiązanie (TW, 2025-01-15)
int max(int a, int b) {
    return (a > b ? a : b);
}

int wys(Twezel *d) { // wysokość liczona w węzłach
    if (d==NULL) return 0;
    return 1 + max(wys(d->lsyn), wys(d->psyn));
}

Twezel *_uzupelnij(Twezel *d, int h) {
    if (d == NULL) {
        assert(h>=0);
        if (h==0) return NULL;
        d = nowy(0, NULL, NULL);
    }
    d->lsyn = _uzupelnij(d->lsyn, h - 1);
    d->psyn = _uzupelnij(d->psyn, h - 1);
    return d;
}

void uzupelnij(Twezel *d) {
    if (d==NULL) return;
    int h = wys(d);
    _uzupelnij(d, h);
}
// -------------------

int main(void) {
    Twezel *d = czytaj();

#if defined(DOT)
    prolog_dot();
    pokaz_dot(d, "przed");
#elif defined(JSON)
    prolog_json();
    pokaz_json(d, "przed");
#else
    printf("przed:\n");
    pisz(d);
#endif

    uzupelnij(d);

#if defined(DOT)
    interlog_dot();
    pokaz_dot(d, "po");
    epilog_dot();
#elif defined(JSON)
    interlog_json();
    pokaz_json(d, "po");
    epilog_json();
#else
    printf("\n");
    printf("po: ");
    pisz(d);
#endif

    usun(d);
    return 0;
}